//*****************************************************************************
// File Name            : sqm_nios2.v
//-----------------------------------------------------------------------------
// Function             : sqm_nios2 top
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2013/01/10 
//*****************************************************************************
module sqm_nios2 (/*
		input  wire        clk_clk,       //   clk.clk
		input  wire        reset_reset_n, // reset.reset_n
		output wire [1:0] led     //   pio.export
		*/
    input clk,
    input rst_n,
	input uart_rxd,
	output uart_txd,
    output led,
    output y,
	 output a_c
		
	);
	 //wire [31:0] pio_export;  //   pio.export
	 
	 wire [31:0] GPO1;
	 wire [3:0] A;
	 wire [3:0] B;
	 wire [3:0] C;

    wire rst;
    wire Reset;
    wire Reset_n;
	wire clk_50m;
	wire sound_clk;
    wire LOCKED;
 assign srst = ~rst_n;
 clk_gen clk_gen(
	.areset(),
	.inclk0(clk), //IN 50MHz
	.c0(clk_50m), //OUT 50MHz
	.c1(sound_clk), //OUT 3.571MHz
	.locked(LOCKED)
	);
	
assign Reset_n =((rst_n==1'b0)||(LOCKED==1'b0))?1'b0:1'b1;
assign a_c = sound_clk;

nios2  nios2(
		.clk_clk(clk_50m),       //   clk.clk
		.reset_reset_n( Reset_n ), // reset.reset_n
		.pio_export (GPO1) ,   //   pio.export
		.uart_rxd(uart_rxd),
		.uart_txd(uart_txd)
		);
		
//PSG
		
AY_3_8910_capcom 
#(1,0) 
ay( .reset_n( Reset_n), .clk(clk_50m), // CPU clock
     .sound_clk(sound_clk), // normally slower than the CPU clock
     .din(GPO1[7:0]), .adr(GPO1[8]), .cs_n( GPO1[9]), .wr_n( GPO1[10]),
     .A(A),.B(B),.C(C) // channel outputs
);
//PWM
da_e_pwm pwm (
	.clk(clk_50m), 
	.reset_n(Reset_n), 
	.din_a(A),.din_b(B),.din_c(C), 
	.pwm(y)
	);
	
//LED
assign led = GPO1[31];
		//assign led = pio_export[31:30];
		
		endmodule